#ifndef _MIKONONS_H
#define _MIKONONS_H
#define MAXTHREADS 16
#include "types.h"

/* Syscall mnemonic values */
#define SYS_SEND              1
#define SYS_RECV              2
#define SYS_REPLY             3

/* service request values */
#define CREATE              1
#define TERMINATE           2
#define SPECPRGMGR          3
#define SPECTLBMGR          4
#define SPECSYSMGR          5
#define GETCPUTIME          6
#define WAITFORCLOCK        7
#define WAITFORIO           8
#define GETTSTATE           9

#define PSEUDOCLOCK         100

/* specific message values */
#define ANYTID          255
#define TRAPCONTINUE          1
#define TRAPTERMINATE       0

#define CREATENOGOOD          -1
                      /* For thread creation failure */
#define MSGNOGOOD           -1
                      /* For message send failure */

typedef unsigned int status_t;  /* thread status */
typedef unsigned char tid_t;    /* thread identifier */
typedef struct tcb_t {          /* thread control block */
        tid_t           tid;            /* thread identifier */
        status_t         status; /* thread's status */
	state_t  proc_state; /* processor state */
        struct tcb_t    *t_next,        /* pointer to next entry in the thread queue */
                        *inbox;         /* threads waiting to send a message to this thread */
        /* other fields will be added during phase2 development */
} tcb_t;

#define MsgSend(dest,payload) (SYSCALL((unsigned int) SYS_SEND,(unsigned int) (dest),(unsigned int) (payload),0))

#define MsgRecv(source,reply) ((tid_t) SYSCALL((unsigned int) SYS_RECV,(unsigned int) (source),(unsigned int) (reply),0))

#define MsgReply(source,reply) (SYSCALL((unsigned int) SYS_REPLY,(unsigned int) (source),(unsigned int) (reply),0))

#endif

